diff --git a/libavdevice/alsa_dec.c b/libavdevice/alsa_dec.c
index c50ce71..36494e9 100644
--- a/libavdevice/alsa_dec.c
+++ b/libavdevice/alsa_dec.c
@@ -148,7 +148,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass alsa_demuxer_class = {
-    .class_name     = "ALSA demuxer",
+    .class_name     = "ALSA indev",
     .item_name      = av_default_item_name,
     .option         = options,
     .version        = LIBAVUTIL_VERSION_INT,
diff --git a/libavdevice/alsa_enc.c b/libavdevice/alsa_enc.c
index 0bef625..1a6d01e 100644
--- a/libavdevice/alsa_enc.c
+++ b/libavdevice/alsa_enc.c
@@ -151,7 +151,7 @@ static int audio_get_device_list(AVFormatContext *h, AVDeviceInfoList *device_li
 }
 
 static const AVClass alsa_muxer_class = {
-    .class_name     = "ALSA muxer",
+    .class_name     = "ALSA outdev",
     .item_name      = av_default_item_name,
     .version        = LIBAVUTIL_VERSION_INT,
     .category       = AV_CLASS_CATEGORY_DEVICE_AUDIO_OUTPUT,
diff --git a/libavdevice/avfoundation.m b/libavdevice/avfoundation.m
index 08deecf..af8fe31 100644
--- a/libavdevice/avfoundation.m
+++ b/libavdevice/avfoundation.m
@@ -1140,7 +1140,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass avf_class = {
-    .class_name = "AVFoundation input device",
+    .class_name = "AVFoundation indev",
     .item_name  = av_default_item_name,
     .option     = options,
     .version    = LIBAVUTIL_VERSION_INT,
diff --git a/libavdevice/bktr.c b/libavdevice/bktr.c
index 993cc19..2601adb 100644
--- a/libavdevice/bktr.c
+++ b/libavdevice/bktr.c
@@ -341,7 +341,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass bktr_class = {
-    .class_name = "BKTR grab interface",
+    .class_name = "BKTR grab indev",
     .item_name  = av_default_item_name,
     .option     = options,
     .version    = LIBAVUTIL_VERSION_INT,
diff --git a/libavdevice/caca.c b/libavdevice/caca.c
index 47de824..be3ff79 100644
--- a/libavdevice/caca.c
+++ b/libavdevice/caca.c
@@ -220,7 +220,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass caca_class = {
-    .class_name = "caca_outdev",
+    .class_name = "caca outdev",
     .item_name  = av_default_item_name,
     .option     = options,
     .version    = LIBAVUTIL_VERSION_INT,
diff --git a/libavdevice/decklink_dec_c.c b/libavdevice/decklink_dec_c.c
index 91d2839..7aceaf9 100644
--- a/libavdevice/decklink_dec_c.c
+++ b/libavdevice/decklink_dec_c.c
@@ -89,7 +89,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass decklink_demuxer_class = {
-    .class_name = "Blackmagic DeckLink demuxer",
+    .class_name = "Blackmagic DeckLink indev",
     .item_name  = av_default_item_name,
     .option     = options,
     .version    = LIBAVUTIL_VERSION_INT,
diff --git a/libavdevice/decklink_enc_c.c b/libavdevice/decklink_enc_c.c
index 63cbd39..682c714 100644
--- a/libavdevice/decklink_enc_c.c
+++ b/libavdevice/decklink_enc_c.c
@@ -41,7 +41,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass decklink_muxer_class = {
-    .class_name = "Blackmagic DeckLink muxer",
+    .class_name = "Blackmagic DeckLink outdev",
     .item_name  = av_default_item_name,
     .option     = options,
     .version    = LIBAVUTIL_VERSION_INT,
diff --git a/libavdevice/openal-dec.c b/libavdevice/openal-dec.c
index c19048e..57de665 100644
--- a/libavdevice/openal-dec.c
+++ b/libavdevice/openal-dec.c
@@ -241,7 +241,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass class = {
-    .class_name = "openal",
+    .class_name = "openal indev",
     .item_name = av_default_item_name,
     .option = options,
     .version = LIBAVUTIL_VERSION_INT,
diff --git a/libavdevice/oss_dec.c b/libavdevice/oss_dec.c
index d0dc327..13ace70 100644
--- a/libavdevice/oss_dec.c
+++ b/libavdevice/oss_dec.c
@@ -125,7 +125,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass oss_demuxer_class = {
-    .class_name     = "OSS demuxer",
+    .class_name     = "OSS indev",
     .item_name      = av_default_item_name,
     .option         = options,
     .version        = LIBAVUTIL_VERSION_INT,
diff --git a/libavdevice/oss_enc.c b/libavdevice/oss_enc.c
index e3172af..274c760 100644
--- a/libavdevice/oss_enc.c
+++ b/libavdevice/oss_enc.c
@@ -90,7 +90,7 @@ static int audio_write_trailer(AVFormatContext *s1)
 }
 
 static const AVClass oss_muxer_class = {
-    .class_name     = "OSS muxer",
+    .class_name     = "OSS outdev",
     .item_name      = av_default_item_name,
     .version        = LIBAVUTIL_VERSION_INT,
     .category       = AV_CLASS_CATEGORY_DEVICE_AUDIO_OUTPUT,
diff --git a/libavdevice/pulse_audio_dec.c b/libavdevice/pulse_audio_dec.c
index 042fe76..50a3c97 100644
--- a/libavdevice/pulse_audio_dec.c
+++ b/libavdevice/pulse_audio_dec.c
@@ -359,7 +359,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass pulse_demuxer_class = {
-    .class_name     = "Pulse demuxer",
+    .class_name     = "Pulse indev",
     .item_name      = av_default_item_name,
     .option         = options,
     .version        = LIBAVUTIL_VERSION_INT,
diff --git a/libavdevice/pulse_audio_enc.c b/libavdevice/pulse_audio_enc.c
index d430b77..e0a631b 100644
--- a/libavdevice/pulse_audio_enc.c
+++ b/libavdevice/pulse_audio_enc.c
@@ -771,7 +771,7 @@ static const AVOption options[] = {
 };
 
 static const AVClass pulse_muxer_class = {
-    .class_name     = "PulseAudio muxer",
+    .class_name     = "PulseAudio outdev",
     .item_name      = av_default_item_name,
     .option         = options,
     .version        = LIBAVUTIL_VERSION_INT,