diff --git a/libavdevice/avdevice.c b/libavdevice/avdevice.c
index 73c6738383..181ce04188 100644
--- a/libavdevice/avdevice.c
+++ b/libavdevice/avdevice.c
@@ -19,6 +19,8 @@
 #include "libavutil/avassert.h"
 #include "libavutil/samplefmt.h"
 #include "libavutil/pixfmt.h"
+#include "libavutil/pixdesc.h"
+#include "libavutil/avutil.h"
 #include "libavcodec/avcodec.h"
 #include "avdevice.h"
 #include "internal.h"
@@ -128,6 +130,83 @@ int avdevice_capabilities_create(AVDeviceCapabilitiesQuery **caps, AVFormatConte
     return ret;
 }
 
+static const AVClass avdevice_capabilities_context_class = {
+    .class_name = "AVDeviceCapabilitiesQuery",
+    .item_name = av_default_item_name,
+    .option = ff_device_capabilities,
+    .version = LIBAVUTIL_VERSION_INT
+};
+
+const AVClass *avdevice_capabilities_get_class(void)
+{
+    return &avdevice_capabilities_context_class;
+}
+
+int avdevice_capabilities_bprint_num(AVBPrint *bp, const char *name, double val)
+{
+    int opt_type_set = 0, is_codec = 0;
+    enum AVOptionType type;  // will be set below, opt_type_set tracks if has been set
+    const AVClass *cap_class = avdevice_capabilities_get_class();
+
+    // may fail, e.g. if name of a component of a multi-component option was provided as input
+    const AVOption *field = av_opt_find(&cap_class, name, NULL, 0, AV_OPT_SEARCH_FAKE_OBJ);
+    if (field) {
+        type = field->type;
+        opt_type_set = 1;
+    }
+
+    // based on name, a type override or other extra info may be needed
+    if (opt_type_set && type==AV_OPT_TYPE_INT && strcmp(name, "codec")==0)
+        is_codec = 1;
+    // next three are for the three components of a AV_OPT_TYPE_IMAGE_SIZE
+    // NB: these wont be found by av_opt_find above
+    else if (
+        strcmp(name, ff_device_get_query_component_name(AV_DEV_CAP_QUERY_WINDOW_SIZE, 0))==0 ||
+        strcmp(name, ff_device_get_query_component_name(AV_DEV_CAP_QUERY_WINDOW_SIZE, 1))==0 ||
+        strcmp(name, ff_device_get_query_component_name(AV_DEV_CAP_QUERY_WINDOW_SIZE, 2))==0
+        ) {
+        type = AV_OPT_TYPE_INT;
+        opt_type_set = 1;
+    }
+
+    // now, format if type set, else error
+    if (!opt_type_set) {
+        av_log(NULL, AV_LOG_ERROR, "A device capability with the name '%s' is not known\n", name);
+        return AVERROR_OPTION_NOT_FOUND;
+    }
+
+    switch (type)
+    {
+    case AV_OPT_TYPE_INT:
+    {
+        int temp = lrint(val);
+        if (is_codec)
+            av_bprintf(bp, "%s", (char *)avcodec_get_name((enum AVCodecID)lrint(val)));
+        else
+            av_bprintf(bp, "%d", temp);
+        break;
+    }
+    case AV_OPT_TYPE_PIXEL_FMT:
+        av_bprintf(bp, "%s", (char *)av_x_if_null(av_get_pix_fmt_name((enum AVPixelFormat)lrint(val)), "none"));
+        break;
+    case AV_OPT_TYPE_SAMPLE_FMT:
+        av_bprintf(bp, "%s", (char *)av_x_if_null(av_get_sample_fmt_name((enum AVSampleFormat)lrint(val)), "none"));
+        break;
+    case AV_OPT_TYPE_DOUBLE:
+        av_bprintf(bp, "%f", val);
+        break;
+    case AV_OPT_TYPE_CHANNEL_LAYOUT:
+        av_bprintf(bp, "0x%"PRIx64, llrint(val));
+        break;
+
+    default:
+        av_log(NULL, AV_LOG_ERROR, "avdevice_capabilities_bprint_num is not implemented for this option type\n", name);
+        return AVERROR_PATCHWELCOME;
+    }
+
+    return 0;
+}
+
 void avdevice_capabilities_free(AVDeviceCapabilitiesQuery **caps, AVFormatContext *s)
 {
     if (!s || !caps || !(*caps))
diff --git a/libavdevice/avdevice.h b/libavdevice/avdevice.h
index 758c650636..11d1a6ae12 100644
--- a/libavdevice/avdevice.h
+++ b/libavdevice/avdevice.h
@@ -48,6 +48,7 @@
 #include "libavutil/log.h"
 #include "libavutil/opt.h"
 #include "libavutil/dict.h"
+#include "libavutil/bprint.h"
 #include "libavformat/avformat.h"
 
 /**
@@ -402,6 +403,16 @@ int avdevice_dev_to_app_control_message(struct AVFormatContext *s,
  */
 typedef struct AVDeviceCapabilitiesQuery AVDeviceCapabilitiesQuery;
 
+/**
+ * Get the AVClass for AVDeviceCapabilitiesQuery. It can be used
+ * in combination with AV_OPT_SEARCH_FAKE_OBJ for examining
+ * which capabilities can be queried through the
+ * AVDeviceCapabilitiesQuery API.
+ *
+ * @see av_opt_find(), av_opt_next().
+ */
+const AVClass *avdevice_capabilities_get_class(void);
+
 /**
  * Initialize capabilities probing API based on AVOption API.
  *
@@ -422,6 +433,22 @@ typedef struct AVDeviceCapabilitiesQuery AVDeviceCapabilitiesQuery;
 int avdevice_capabilities_create(AVDeviceCapabilitiesQuery **caps, AVFormatContext *s,
                                  AVDictionary **device_options);
 
+/**
+ * Format a capabilities value as string and append to a bprint buffer.
+ * @param  bp A buffer to which the output string will be
+ *         appended.
+ * @param  name Name of the option to print (provide
+ *         AVOptionRange.str).
+ * @param  val An capabilities value represented as a
+ *         double (e.g. min_value or max_value of
+ *         AVOptionRange)
+ * @return 0 on success, a negative error code otherwise. Even if
+ * return value indicates success, the state of the bp variable
+ * should also be checked, as it may have experienced memory allocation
+ * trouble.
+ */
+int avdevice_capabilities_bprint_num(AVBPrint *bp, const char *name, double val);
+
 /**
  * Free resources created by avdevice_capabilities_create()
  *
diff --git a/libavdevice/version.h b/libavdevice/version.h
index 0df40ef4c7..8f92c3b85b 100644
--- a/libavdevice/version.h
+++ b/libavdevice/version.h
@@ -28,8 +28,8 @@
 #include "libavutil/version.h"
 
 #define LIBAVDEVICE_VERSION_MAJOR  59
-#define LIBAVDEVICE_VERSION_MINOR   3
-#define LIBAVDEVICE_VERSION_MICRO 102
+#define LIBAVDEVICE_VERSION_MINOR   4
+#define LIBAVDEVICE_VERSION_MICRO 100
 
 #define LIBAVDEVICE_VERSION_INT AV_VERSION_INT(LIBAVDEVICE_VERSION_MAJOR, \
                                                LIBAVDEVICE_VERSION_MINOR, \