diff --git a/libavdevice/avdevice.c b/libavdevice/avdevice.c
index 833d200054..98934abfb7 100644
--- a/libavdevice/avdevice.c
+++ b/libavdevice/avdevice.c
@@ -19,6 +19,7 @@
 #include "libavutil/avassert.h"
 #include "libavutil/samplefmt.h"
 #include "libavutil/pixfmt.h"
+#include "libavformat/version.h"
 #include "avdevice.h"
 #include "internal.h"
 #include "config.h"
@@ -39,6 +40,18 @@ unsigned avdevice_version(void)
     return LIBAVDEVICE_VERSION_INT;
 }
 
+unsigned avdevice_version_same_minor(void)
+{
+    // check version of loaded lavf has same major and minor version as
+    // this library was compiled against
+    // NB: this function doesn't have to be called, dynamic linker will
+    // signal error when avformat of wrong major or minor version is found.
+    if ((avformat_version_same_minor()) & ~0xFF != (LIBAVFORMAT_VERSION_INT & ~0xFF))
+        abort();
+
+    return avdevice_version();
+}
+
 const char * avdevice_configuration(void)
 {
     return FFMPEG_CONFIGURATION;
diff --git a/libavdevice/avdevice.h b/libavdevice/avdevice.h
index 0b32e59fed..db16a2f27e 100644
--- a/libavdevice/avdevice.h
+++ b/libavdevice/avdevice.h
@@ -47,6 +47,16 @@
  *
  * To use libavdevice, simply call avdevice_register_all() to register all
  * compiled muxers and demuxers. They all use standard libavformat API.
+ * 
+ * Note that libavdevice is locked to be used with the same major and minor
+ * version of libavformat that it was built against. Attempting to use a 
+ * shared build of FFmpeg or its libavdevice library with a libavformat of
+ * a different major or minor version will generate a dynamic linker error.
+ * This is achieved by the internal function check_avformat_same_minor() in 
+ * avdevice.c. This function does not have to be called, its call to
+ * avformat_version_same_minor() (a macro which expands to a name with the
+ * specific major and minor version of avformat embedded in it) is sufficient
+ * to trigger link failure.
  *
  * @{
  */
diff --git a/libavdevice/version.h b/libavdevice/version.h
index 09c1d778dc..4efe7f8649 100644
--- a/libavdevice/version.h
+++ b/libavdevice/version.h
@@ -26,10 +26,11 @@
  */
 
 #include "libavutil/version.h"
+#include "libavutil/macros.h"
 
 #include "version_major.h"
 
-#define LIBAVDEVICE_VERSION_MINOR   6
+#define LIBAVDEVICE_VERSION_MINOR   7
 #define LIBAVDEVICE_VERSION_MICRO 100
 
 #define LIBAVDEVICE_VERSION_INT AV_VERSION_INT(LIBAVDEVICE_VERSION_MAJOR, \
@@ -42,4 +43,14 @@
 
 #define LIBAVDEVICE_IDENT       "Lavd" AV_STRINGIFY(LIBAVDEVICE_VERSION)
 
+/**
+ * avdevice_version_same_minor() expands to a function with
+ * the same minor and major version it was compiled against
+ * encoded in it. Enables locking to the minor version of
+ * other libraries they were compiled against. Does not have
+ * to be called by user.
+ */
+#define avdevice_version_same_minor AV_MAKE_MAJOR_MINOR_FUNC_NAME(device,LIBAVFORMAT_VERSION_MAJOR,LIBAVFORMAT_VERSION_MINOR)
+unsigned avdevice_version_same_minor(void);
+
 #endif /* AVDEVICE_VERSION_H */
diff --git a/libavformat/avformat.h b/libavformat/avformat.h
index f12fa7d904..350912e272 100644
--- a/libavformat/avformat.h
+++ b/libavformat/avformat.h
@@ -64,6 +64,9 @@
  * set by user for input, always set by user for output (unless you are dealing
  * with an AVFMT_NOFILE format).
  *
+ * Note that libavdevice is locked to a specific major and minor version of
+ * libavformat, see @ref lavd "libavdevice" for more details.
+ *
  * @section lavf_options Passing options to (de)muxers
  * It is possible to configure lavf muxers and demuxers using the @ref avoptions
  * mechanism. Generic (format-independent) libavformat options are provided by
diff --git a/libavformat/utils.c b/libavformat/utils.c
index 3f253c2045..6d9c4e778a 100644
--- a/libavformat/utils.c
+++ b/libavformat/utils.c
@@ -64,6 +64,11 @@ unsigned avformat_version(void)
     return LIBAVFORMAT_VERSION_INT;
 }
 
+unsigned avformat_version_same_minor(void)
+{
+    return avformat_version();
+}
+
 const char *avformat_configuration(void)
 {
     return FFMPEG_CONFIGURATION;
diff --git a/libavformat/version.h b/libavformat/version.h
index f4a26c2870..bb6a7d4510 100644
--- a/libavformat/version.h
+++ b/libavformat/version.h
@@ -28,11 +28,12 @@
  */
 
 #include "libavutil/version.h"
+#include "libavutil/macros.h"
 
 #include "version_major.h"
 
-#define LIBAVFORMAT_VERSION_MINOR  20
-#define LIBAVFORMAT_VERSION_MICRO 101
+#define LIBAVFORMAT_VERSION_MINOR  21
+#define LIBAVFORMAT_VERSION_MICRO 100
 
 #define LIBAVFORMAT_VERSION_INT AV_VERSION_INT(LIBAVFORMAT_VERSION_MAJOR, \
                                                LIBAVFORMAT_VERSION_MINOR, \
@@ -44,4 +45,13 @@
 
 #define LIBAVFORMAT_IDENT       "Lavf" AV_STRINGIFY(LIBAVFORMAT_VERSION)
 
+/**
+ * avformat_version_same_minor() expands to a function with
+ * the same minor and major version it was compiled against
+ * encoded in it. Enables locking to the minor version of
+ * other libraries they were compiled against. 
+ */
+#define avformat_version_same_minor AV_MAKE_MAJOR_MINOR_FUNC_NAME(format,LIBAVFORMAT_VERSION_MAJOR,LIBAVFORMAT_VERSION_MINOR)
+unsigned avformat_version_same_minor(void);
+
 #endif /* AVFORMAT_VERSION_H */
diff --git a/libavutil/avutil.h b/libavutil/avutil.h
index 4d633156d1..94ce472c27 100644
--- a/libavutil/avutil.h
+++ b/libavutil/avutil.h
@@ -76,6 +76,9 @@
  * situations may change slightly (and be documented). All those are accompanied
  * by an entry in doc/APIchanges and incrementing either the minor or micro
  * version number.
+ *
+ * Note that libavdevice is locked to a specific major and minor version of
+ * libavformat, see @ref lavd "libavdevice" for more details.
  */
 
 /**
diff --git a/libavutil/macros.h b/libavutil/macros.h
index 2a7567c3ea..dab530a8a0 100644
--- a/libavutil/macros.h
+++ b/libavutil/macros.h
@@ -73,6 +73,9 @@
  * @}
  */
 
+#define AV_MAKE_MAJOR_MINOR_FUNC_NAME_IMPL(name,major,minor) av ## name ## _version_ ## major ## _ ## minor
+#define AV_MAKE_MAJOR_MINOR_FUNC_NAME(name,major,minor) AV_MAKE_MAJOR_MINOR_FUNC_NAME_IMPL(name,major,minor)
+
 #define AV_PRAGMA(s) _Pragma(#s)
 
 #define FFALIGN(x, a) (((x)+(a)-1)&~((a)-1))